﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
'
' Inspired by Erel --> https://www.b4x.com/android/forum/threads/classes-are-soon-coming.18395/
' 
'***************************
' Usage example
'***************************
'Sub Activity_Create(FirstTime As Boolean)
'   Activity.LoadLayout("1")
'   Dim dv1 As draggableview
'   dv1.Initialize(Activity, Label1)
'End Sub
'***************************


Sub Class_Globals
	Private innerView As B4XView
	Private TouchPanelOverBubble As Panel
	Private downx As Int
	Private downy As Int
	Private ACTION_DOWN, ACTION_MOVE, ACTION_UP As Int
	
	Private cvs As B4XCanvas
	Private av As B4XView
	Private panX As Panel
	Private bcolor As Int
	Private shadowwidth As Int = 2dip
End Sub

Sub Initialize(ParentPanel As Panel, ViewToBlubble As B4XView, AnchorView As View, BackColor As Int)
	panX = ParentPanel
	av = AnchorView 
	bcolor = BackColor
	cvs.Initialize(panX)
	
	innerView = ViewToBlubble
	TouchPanelOverBubble.Initialize("") 
	TouchPanelOverBubble.Color = Colors.Transparent
	ViewToBlubble.SetColorAndBorder(bcolor, 0, 0, 5dip)

	panX.AddView(TouchPanelOverBubble, ViewToBlubble.Left, ViewToBlubble.Top, ViewToBlubble.Width, ViewToBlubble.Height)

	ACTION_DOWN = panX.ACTION_DOWN
	ACTION_MOVE = panX.ACTION_MOVE
	ACTION_UP = panX.ACTION_UP
   
	Dim r As Reflector
	r.Target = TouchPanelOverBubble
	r.SetOnTouchListener("Panel1_Touch") 'why reflection instead of the regular Panel_Touch event? Good question which deserves a forum thread of its own (not related to classes)...
	BubbleMoved
	
End Sub

Private Sub Panel1_Touch (o As Object, ACTION As Int, x As Float, y As Float, motion As Object) As Boolean
	If ACTION = ACTION_DOWN Then
		downx = x
		downy = y
	Else
		innerView.Left = innerView.Left + x - downx
		innerView.Top = innerView.Top + y - downy
		TouchPanelOverBubble.Left = innerView.Left
		TouchPanelOverBubble.Top = innerView.Top
		BubbleMoved
	End If
	Return True
End Sub

private Sub BubbleMoved
	cvs.ClearRect(cvs.TargetRect)
	
	' --- Draw shadow for inner view
	Dim l,t,r,b As Float
	l = innerView.Left
	t = innerView.Top +shadowwidth 
	r = innerView.Left + innerView.Width
	b = innerView.Top + innerView.Height +shadowwidth 
	Dim ivrec As B4XRect
	ivrec.Initialize(l,t,r,b)
	Dim path As B4XPath
	path.InitializeRoundedRect(ivrec, 5dip)
	cvs.ClipPath(path)
	cvs.DrawRect(cvs.TargetRect,  Colors.ARGB(3* 24, 160, 160, 160) , True, shadowwidth)
	cvs.RemoveClip
	
	' --- Draw shadow for pointer
	For i = 0 To 3
		Dim bpa As B4XPath
		bpa.Initialize(innerView.Left +(innerView.Width/2), innerView.Top +(innerView.Height /2))
		bpa.LineTo( av.Left +(av.Height /2), av.Top + (av.Height /2) )
		bpa.LineTo( innerView.Left +(innerView.Width/2), innerView.Top +(innerView.Height /2) +24dip + i*shadowwidth)
		cvs.DrawPath(bpa, Colors.ARGB(i*24, 160, 160, 160), True, 0)
	Next
	
	' --- Draw pointer
	Dim bpa As B4XPath
	bpa.Initialize(innerView.Left +(innerView.Width/2), innerView.Top +(innerView.Height /2))
	bpa.LineTo( av.Left +(av.Height /2), av.Top + (av.Height /2))
	bpa.LineTo( innerView.Left +(innerView.Width/2), innerView.Top +(innerView.Height /2) +24dip)
	cvs.DrawPath(bpa, bcolor, True, 0)
	
	panX.Invalidate
End Sub
 